import { Component, OnInit } from "@angular/core";
import { FormArray, FormBuilder, FormGroup, Validators } from "@angular/forms";
import { ActivatedRoute, Router } from "@angular/router";
import { BlockUI, NgBlockUI } from "ng-block-ui";

@Component({
  selector: "app-add-new-building-room",
  templateUrl: "./add-new-building-room.component.html",
  styleUrls: ["./add-new-building-room.component.css"],
})
export class AddNewBuildingRoomComponent implements OnInit {
  public breadcrumb: any;
  mode: string;
  userProfileForm: FormGroup;
  public userList: FormArray;
  submitted = false;
  get userFormGroup() {
    return this.userProfileForm.get('userArray') as FormArray;
  }

  constructor(
    private formBuilder: FormBuilder,
    private router: Router,
    private route: ActivatedRoute
  ) {}

  ngOnInit() {
    this.breadcrumb = {
      mainlabel: "Add building",
      links: [
        {
          name: "Add Building",
          isLink: false,
        },
      ],
    };
    this.userProfileForm = this.formBuilder.group({
      buildingId: ['', Validators.required],
      roomId: ['', Validators.required],
      floorId: ['', Validators.required],
      userArray: this.formBuilder.array([this.createPhone()]),
    });

    this.userList = this.userProfileForm.get('userArray') as FormArray;
  }

  createPhone(): FormGroup {
    return this.formBuilder.group({
      roomId: ['', Validators.required]
    });
  }

  addPhone() {
    this.userList.push(this.createPhone());
  }

  removePhone(index) {
    this.userList.removeAt(index);
  }

  cancel() {
    this.router.navigate(["/monitoring"]);
  }
}
